POJ 3709 Round Numbers 数位dp

来源:互联网 发布:华沙 知乎 编辑:程序博客网 时间:2024/06/05 15:45

Round Numbers

Time Limit: 2000MS Memory Limit: 65536K
Total Submissions: 14400 Accepted: 5772

Description

The cows, as you know, have no fingers or thumbs and thus are unable to play Scissors, Paper, Stone’ (also known as ‘Rock, Paper, Scissors’, ‘Ro, Sham, Bo’, and a host of other names) in order to make arbitrary decisions such as who gets to be milked first. They can’t even flip a coin because it’s so hard to toss using hooves.

They have thus resorted to “round number” matching. The first cow picks an integer less than two billion. The second cow does the same. If the numbers are both “round numbers”, the first cow wins,
otherwise the second cow wins.

A positive integer N is said to be a “round number” if the binary representation of N has as many or more zeroes than it has ones. For example, the integer 9, when written in binary form, is 1001. 1001 has two zeroes and two ones; thus, 9 is a round number. The integer 26 is 11010 in binary; since it has two zeroes and three ones, it is not a round number.

Obviously, it takes cows a while to convert numbers to binary, so the winner takes a while to determine. Bessie wants to cheat and thinks she can do that if she knows how many “round numbers” are in a given range.

Help her by writing a program that tells how many round numbers appear in the inclusive range given by the input (1 ≤ Start < Finish ≤ 2,000,000,000).

Input

Line 1: Two space-separated integers, respectively Start and Finish.

Output

Line 1: A single integer that is the count of round numbers in the inclusive range Start..Finish

Sample Input

2 12

Sample Output

6

Source

USACO 2006 November Silver

题意:
求出在[l,r]中,有多少个数的二进制表示后,0的数量比1多。

题解:
二进制枚举来进行dp
用num表示1比0多的数目。

#include<cstdio>#include<cstring>#include<algorithm>#include<iostream>#define ll long longusing namespace std;const int N = 35;const int M = 65;int l,r;int cnt=0,a[N];ll dp[N][M];//num表示1比0多的数量ll dfs(int pos,int num,bool zero,bool limit){    if(pos<=-1) return (num<=32);    if((!zero)&&(!limit)&&dp[pos][num]!=-1)       return dp[pos][num];    int mx;if(limit) mx=a[pos];    else mx=1;ll ans=0;    for(int i=0;i<=mx;i++){        if(zero&&i==0) ans+=dfs(pos-1,num,zero,limit&&i==mx);        else if(i==0) ans+=dfs(pos-1,num-1,zero,limit&&i==mx);        else ans+=dfs(pos-1,num+1,0,limit&&i==mx);    }    if(!limit&&!zero) dp[pos][num]=ans;    return ans;}ll getans(int x){    cnt=0;    while(x){        a[cnt++]=x&1;        x>>=1;    }    return dfs(cnt-1,32,1,1);}int main(){    scanf("%d%d",&l,&r);    memset(dp,-1,sizeof(dp));    cout<<getans(r)-getans(l-1)<<endl;    return 0;}
原创粉丝点击